"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var lodash_1 = __importDefault(require("lodash"));
var inversify_1 = require("inversify");
var index_1 = require("./index");
var ProtocultureServiceProvider_1 = require("./ProtocultureServiceProvider");
var Bundle = (function () {
    function Bundle() {
        this.loadServiceProviders();
    }
    Object.defineProperty(Bundle.prototype, "containerConfiguration", {
        get: function () { return null; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Bundle.prototype, "heartbeatInterval", {
        get: function () { return 1; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Bundle.prototype, "serviceProviders", {
        get: function () {
            return [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Bundle.prototype, "container", {
        get: function () {
            return this._container;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Bundle.prototype, "workingApps", {
        get: function () {
            return lodash_1.default.filter(this.apps, function (app) {
                return app.working;
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Bundle.prototype, "longRunning", {
        get: function () {
            return !!this.workingApps.length;
        },
        enumerable: true,
        configurable: true
    });
    Bundle.prototype.boot = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.booted = false;
                        this.bootContainer();
                        return [4, this.bootServiceProviders()];
                    case 1:
                        _a.sent();
                        return [4, this.bootLogging()];
                    case 2:
                        _a.sent();
                        this.booted = true;
                        return [2];
                }
            });
        });
    };
    Bundle.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var error_1, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.booted) return [3, 2];
                        return [4, this.boot()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        if (!lodash_1.default.isEmpty(this.apps)) {
                            this.logger.log("Bundle already running.", null);
                            return [2];
                        }
                        this.logger.log("Running bundle.", null);
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 5, , 6]);
                        return [4, this.buildApps()];
                    case 4:
                        _a.sent();
                        return [3, 6];
                    case 5:
                        error_1 = _a.sent();
                        this.logger.log("Unable to build apps: " + error_1, null);
                        return [3, 6];
                    case 6:
                        _a.trys.push([6, 8, , 9]);
                        return [4, this.runApps()];
                    case 7:
                        _a.sent();
                        return [3, 9];
                    case 8:
                        error_2 = _a.sent();
                        this.logger.log("Error running apps: " + error_2, null);
                        return [3, 9];
                    case 9: return [2];
                }
            });
        });
    };
    Bundle.prototype.bootChild = function () {
        return __awaiter(this, void 0, void 0, function () {
            var childContainer, bootPromises;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        childContainer = this.container.createChild();
                        bootPromises = lodash_1.default.map(this.loadedServiceProviders, function (serviceProvider) {
                            return serviceProvider.bootChild(childContainer);
                        });
                        return [4, Promise.all(bootPromises)];
                    case 1:
                        _a.sent();
                        return [2, childContainer];
                }
            });
        });
    };
    Bundle.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    this.logger.log("Teardown APIs have not been implemented yet.", null);
                }
                catch (error) {
                    this.logger.log(error.stack, null);
                }
                return [2];
            });
        });
    };
    Bundle.prototype.loadServiceProviders = function () {
        var _this = this;
        var internalServiceProviders = [
            ProtocultureServiceProvider_1.ProtocultureServiceProvider,
            index_1.LogServiceProvider,
        ];
        var serviceProviders = lodash_1.default.concat(internalServiceProviders, this.serviceProviders);
        this.loadedServiceProviders = lodash_1.default.map(serviceProviders, function (serviceProvider) {
            return new serviceProvider(_this);
        });
    };
    Bundle.prototype.bootContainer = function () {
        if (this.containerConfiguration) {
            this._container = new inversify_1.Container(this.containerConfiguration);
        }
        else {
            this._container = new inversify_1.Container();
        }
    };
    Bundle.prototype.bootServiceProviders = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, lodash_1.default.reduce(this.loadedServiceProviders, function (previous, current) { return previous.then(function () { return current.boot(); }); }, new Promise(function (resolve) { return resolve(); }))];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Bundle.prototype.bootLogging = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.logger = this.container.get(index_1.protocultureSymbols.LogService) || this.logger;
                return [2];
            });
        });
    };
    Bundle.prototype.buildApps = function () {
        this.logger.log("Building apps", null);
        this.apps = this.container.getAll(index_1.protocultureSymbols.App);
    };
    Bundle.prototype.startHeartbeat = function () {
        var _this = this;
        var interval = this.heartbeatInterval * 1000;
        var timer;
        var complete;
        var deferred = new Promise(function (resolve) { return complete = resolve; });
        timer = setInterval(function () { return _this.tick(timer, complete); }, interval);
        return deferred;
    };
    Bundle.prototype.tick = function (timer, complete) {
        this.logger.log("Beat...", null);
        if (!this.longRunning) {
            this.logger.log("...Heart beat.", null);
            clearInterval(timer);
            complete();
        }
    };
    Bundle.prototype.runApps = function () {
        return __awaiter(this, void 0, void 0, function () {
            var appPromises;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.log("Running apps", null);
                        appPromises = lodash_1.default.map(this.apps, function (app) { return _this.runApp(app); });
                        this.logger.log("All apps started", null);
                        return [4, Promise.all(appPromises)];
                    case 1:
                        _a.sent();
                        return [4, this.longRunning];
                    case 2:
                        (_a.sent())
                            ? this.startHeartbeat()
                            : null;
                        return [4, this.stop()];
                    case 3:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Bundle.prototype.runApp = function (app) {
        return __awaiter(this, void 0, void 0, function () {
            var error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.log("Starting app", app);
                        app.bundle = this;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, app.run()];
                    case 2:
                        _a.sent();
                        return [3, 4];
                    case 3:
                        error_3 = _a.sent();
                        this.logger.log(error_3.stack, app);
                        return [3, 4];
                    case 4: return [2];
                }
            });
        });
    };
    return Bundle;
}());
exports.Bundle = Bundle;
//# sourceMappingURL=Bundle.js.map